/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mb;

import domen.Korisnik;
import domen.Mesto;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import kontroler.Kontroler;

/**
 *
 * @author student
 */
@Named(value = "mbKorisnik")
@SessionScoped
public class MBKorisnik implements Serializable {

    @Inject
    Kontroler kontroler;

    /**
     * Creates a new instance of MBKorisnik
     */
    public MBKorisnik() {
        korisnik = new Korisnik();        
    }
    
    
    @PostConstruct
    public void inicijalizujPodatke(){
        
        listaMesta = kontroler.vratiListuMesta();
        
    }
    

    private Korisnik korisnik;

    private String ponovljenaSifra;
    
    private List<Mesto> listaMesta;
    

    public Korisnik getKorisnik() {
        return korisnik;
    }

    public void setKorisnik(Korisnik korisnik) {
        this.korisnik = korisnik;
    }

    public String getPonovljenaSifra() {
        return ponovljenaSifra;
    }

    public void setPonovljenaSifra(String ponovljenaSifra) {
        this.ponovljenaSifra = ponovljenaSifra;
    }

    public List<Mesto> getListaMesta() {
        return listaMesta;
    }

    public void setListaMesta(List<Mesto> listaMesta) {
        this.listaMesta = listaMesta;
    }
    
    

    public String prijaviKorisnika() {

        System.out.println("POZVANA JE METODA - PRIJAVI KORISNIKA");
        System.out.println("Korisnicko ime:" + korisnik.getKorisnickoime() + ", korisnicka sifra:" + korisnik.getKorisnickasifra());
        try {
            korisnik = kontroler.prijaviKorisnika(korisnik);
            return "profilnaStrana.xhtml";
//            System.out.println("SVE JE OK!!!");
        } catch (Exception ex) {
            System.out.println("GRESKA:" + ex);

        }
        return null;
    }

    public String sacuvajKorisnika() {

        System.out.println("CUVAM KORISNIKA");
        System.out.println("Mesto u korisniku:"+korisnik.getMesto());
        try {
            
            if (!korisnik.getKorisnickasifra().equals(ponovljenaSifra)){
                
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Korisnicka sifra nije ista kao ponovljena!!!", "Detalji poruke o gresci!!!"));
                return null;
            }
            
            kontroler.sacuvajKorisnika(korisnik);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "USPESNO STE IZMENILI PODATKE", "Detalji poruke!!!"));
            
        } catch (Exception ex) {

            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "GRESKA:"+ex.getMessage(), "Detalji poruke o gresci!!!"));
        }
        return null;

    }

}
